import java.net.*;
import java.io.*;

public class DataChatter extends Thread
{
	DataMultiChatServer m;

   Socket sock;
   DataInputStream i;
   DataOutputStream o;

  /**
  	accetta la socket gia' creata
  */
  public DataChatter(DataMultiChatServer m,Socket s)
  {
  	  this.m=m;
     sock=s;
  }

  public void send(String msg)
  {
      try
      {
	      o.writeUTF(msg); // ed ecco l'echo...
      }
      catch(Exception e)
      {
	      e.printStackTrace();
      } 
  }

  /**
  	gestisce l'echo
  */
  public void run()
  {
      try
      {
         i=new DataInputStream(sock.getInputStream());
         o=new DataOutputStream(sock.getOutputStream());

         while(true)
         {
				String msg=i.readUTF(); // bloccante !!!
				m.broadcast(msg); // lo passa al gestore per la trasmissione a tutti
         }
      }
      catch(Exception e)
      {
	      e.printStackTrace();
      } 
   }
}
