import java.net.*;
import java.io.*;
import java.awt.*;
import java.awt.event.*;

public class ObjClient
	extends Frame
	implements Runnable, ActionListener
{
	// cambiare questa per connettersi ad un altro host
	public final static String HOST="127.0.0.1";

	TextField tx,nome;
	TextArea rx;

	Thread t;
	
	Socket sock;
   ObjectInputStream i;
   ObjectOutputStream o;

  public ObjClient()
  {
  	super("ObjClient");
  	setSize(300,300);

  	tx=new TextField();
	tx.addActionListener(this);
	add(BorderLayout.NORTH,tx);

	nome=new TextField();
	add(BorderLayout.SOUTH,nome);

	rx=new TextArea();
	rx.setEditable(false);
	add(rx);
  }

  public void start()
  {
  	try
	{
  		sock=new Socket(HOST,ObjMultiChatServer.DEFAULT_PORT);
      o=new ObjectOutputStream(sock.getOutputStream());
      i=new ObjectInputStream(sock.getInputStream());

	  	t=new Thread(this);
		t.start();
	}
	catch(Exception e)
	{
	 e.printStackTrace();
	}
  }

  public void run()
  {
      try
      {
         while(true)
         {
				Object msg=i.readObject(); // bloccante !!!
				rx.append(msg+"\n");
         }
      }
      catch(Exception e)
      {
	      e.printStackTrace();
      } 
   }

	public void actionPerformed(ActionEvent e)
	{
      try
      {
			o.writeObject(new Message(nome.getText(),tx.getText()));
      }
      catch(Exception ex)
      {
	      ex.printStackTrace();
      } 
	}

   public static void main(String argv[])
   {
		ObjClient d=new ObjClient();
		d.start();
		d.setVisible(true);
	}
}
