import java.util.*;
import java.net.*;
import java.io.*;

public class ObjMultiChatServer
{
	public final static int DEFAULT_PORT=2003;

	Stack chatters;	// per tenere traccia degli Echoer creati

	ServerSocket server;
   Socket s;
   int port=DEFAULT_PORT;

	public ObjMultiChatServer()
	{
      chatters=new Stack();
	}

	public void broadcast(Object msg)
	{
		Enumeration e=chatters.elements();
		while(e.hasMoreElements())
		{
			((ObjChatter)e.nextElement()).send(msg);
		}
	}

   public static void main(String argv[])
   {
		ObjMultiChatServer m=new ObjMultiChatServer();
		m.serve();
	}

	public void serve()
	{
      try
      {
         server = new ServerSocket(port);
      }
      catch(Exception e)
      {
         e.printStackTrace();
      } 

      while(true)
      {
         try
         {
            System.out.print("accepting... on port:"+port);
            s = server.accept();
            System.out.print("... accepted");
            chatters.push(new ObjChatter(this,s));
            ((ObjChatter)chatters.peek()).start();
            System.out.println("... Thread started.");
         }
         catch(Exception e)
         {
            e.printStackTrace();
         } 
      }
   }
}
