import java.net.*;
import java.io.*;
import java.awt.*;
import java.awt.event.*;

public class DataClient
	extends Frame
	implements Runnable, ActionListener
{
	// cambiare questa per connettersi ad un altro host
	public final static String HOST="127.0.0.1";

	TextField tx;
	TextArea rx;

	Thread t;
	
	Socket sock;
   DataInputStream i;
   DataOutputStream o;

  public DataClient()
  {
  	super("DataClient");
  	setSize(300,300);

  	tx=new TextField();
	tx.addActionListener(this);
	add(BorderLayout.NORTH,tx);

	rx=new TextArea();
	rx.setEditable(false);
	add(rx);
  }

  public void start()
  {
  	try
	{
  		sock=new Socket(HOST,DataMultiChatServer.DEFAULT_PORT);
      i=new DataInputStream(sock.getInputStream());
      o=new DataOutputStream(sock.getOutputStream());

	  	t=new Thread(this);
		t.start();
	}
	catch(Exception e)
	{
	 e.printStackTrace();
	}
  }

  public void run()
  {
      try
      {
         while(true)
         {
				String msg=i.readUTF(); // bloccante !!!
				rx.append(msg+"\n");
         }
      }
      catch(Exception e)
      {
	      e.printStackTrace();
      } 
   }

	public void actionPerformed(ActionEvent e)
	{
      try
      {
			o.writeUTF(tx.getText());
      }
      catch(Exception ex)
      {
	      ex.printStackTrace();
      } 
	}

   public static void main(String argv[])
   {
		DataClient d=new DataClient();
		d.setVisible(true);
		d.start();
	}
}
