import java.util.*;
import java.net.*;
import java.io.*;

public class MultiEchoServer
{
   public final static int DEFAULT_PORT=2000;

   public static void main(String argv[])
   {
      ServerSocket server=null;
      Socket s=null;
      int port=DEFAULT_PORT;

      try
      {
         server = new ServerSocket(port);
      }
      catch(Exception e)
      {
         e.printStackTrace();
      } 

      while(true)
      {
         try
         {
            System.out.print("accepting... on port:"+port);
            s = server.accept();
            System.out.print("... accepted:"+s);
            new Echoer(s).start();
            System.out.println("... Echoer started.");
         }
         catch(Exception e)
         {
            e.printStackTrace();
         } 
      }
   }
}
